"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/dialogs/index.ts
var dialogs_exports = {};
__export(dialogs_exports, {
  ConfirmDismissHelptips: () => ConfirmDismissHelptips,
  ConvertedImageNote: () => ConvertedImageNote,
  DeviceConnectionDialog: () => DeviceConnectionDialog,
  DeviceTypeSelectionStep: () => DeviceTypeSelectionStep,
  ExternalProviderTip: () => ExternalProviderTip,
  FeedbackDialog: () => FeedbackDialog,
  InstallationStep: () => InstallationStep,
  LogDialog: () => LogDialog,
  PhysicalDeviceOnboarding: () => PhysicalDeviceOnboarding,
  StartupNotificationDialog: () => StartupNotificationDialog,
  VirtualDeviceOnboarding: () => VirtualDeviceOnboarding,
  getDemoDeviceCreationCommand: () => getDemoDeviceCreationCommand
});
module.exports = __toCommonJS(dialogs_exports);

// src/dialogs/ConfirmDismissHelpTips.tsx
var import_react_redux = require("react-redux");
var import_material = require("@mui/material");
var import_actions = __toESM(require("@northern.tech/store/actions"), 1);
var import_thunks = require("@northern.tech/store/thunks");
var import_jsx_runtime = require("react/jsx-runtime");
var { setShowDismissOnboardingTipsDialog } = import_actions.default;
var ConfirmDismissHelptips = () => {
  const dispatch = (0, import_react_redux.useDispatch)();
  return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_material.Dialog, { open: true, children: [
    /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_material.DialogTitle, { children: "Dismiss the Getting Started help?" }),
    /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_material.DialogContent, { children: "Hide the help tips? You haven't finished your first update yet." }),
    /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_material.DialogActions, { className: "flexbox space-between", children: [
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_material.Button, { onClick: () => dispatch(setShowDismissOnboardingTipsDialog(false)), children: "Cancel" }),
      /* @__PURE__ */ (0, import_jsx_runtime.jsx)(import_material.Button, { variant: "contained", color: "secondary", onClick: () => dispatch((0, import_thunks.setOnboardingCanceled)()), children: "Yes, hide the help" })
    ] })
  ] });
};

// src/dialogs/DeviceConnectionDialog.tsx
var import_react6 = require("react");
var import_react_redux5 = require("react-redux");
var import_react_router_dom2 = require("react-router-dom");
var import_material6 = require("@mui/material");
var import_mui5 = require("tss-react/mui");
var import_helptips2 = require("@northern.tech/common-ui/helptips");
var import_constants5 = require("@northern.tech/store/constants");
var import_selectors4 = require("@northern.tech/store/selectors");
var import_thunks4 = require("@northern.tech/store/thunks");

// ../../assets/img/docker.png
var docker_default = "../docker-NSLOZBPD.png";

// ../../assets/img/raspberrypi4.png
var raspberrypi4_default = "../raspberrypi4-RE2Z6223.png";

// ../../assets/img/raspberrypi.png
var raspberrypi_default = "../raspberrypi-Q67HH5QM.png";

// src/DocsLink.tsx
var import_react2 = require("react");
var import_react_redux2 = require("react-redux");
var import_icons_material2 = require("@mui/icons-material");
var import_material3 = require("@mui/material");
var import_mui2 = require("tss-react/mui");
var import_constants2 = require("@northern.tech/store/constants");
var import_selectors = require("@northern.tech/store/selectors");
var import_debouncehook2 = require("@northern.tech/utils/debouncehook");

// src/MenderTooltip.tsx
var import_react = require("react");
var import_icons_material = require("@mui/icons-material");
var import_material2 = require("@mui/material");
var import_mui = require("tss-react/mui");
var import_constants = require("@northern.tech/store/constants");
var import_debouncehook = require("@northern.tech/utils/debouncehook");
var import_helpers = require("@northern.tech/utils/helpers");
var import_jsx_runtime2 = require("react/jsx-runtime");
var useStyles = (0, import_mui.makeStyles)()((theme) => ({
  icon: {
    "&.read": {
      color: theme.palette.text.disabled
    }
  },
  iconAura: {
    position: "absolute",
    top: -5,
    bottom: 0,
    left: -5,
    right: -5,
    border: `1px dashed ${theme.palette.primary.main}`,
    borderRadius: "50%",
    "&.read": {
      borderColor: theme.palette.text.disabled
    }
  }
}));
var MenderTooltip = (0, import_mui.withStyles)(import_material2.Tooltip, ({ palette, shadows, spacing }) => ({
  arrow: {
    color: palette.background.paper
  },
  tooltip: {
    backgroundColor: palette.background.paper,
    boxShadow: shadows[1],
    color: palette.text.primary,
    padding: spacing(2),
    fontSize: "small",
    maxWidth: 600,
    info: {
      maxWidth: 300,
      color: palette.text.hint,
      backgroundColor: palette.grey[500]
    }
  }
}));
var MenderTooltipClickable = ({
  children,
  onboarding,
  startOpen = false,
  visibility = startOpen,
  onOpenChange,
  tooltipComponent = MenderTooltip,
  ...remainingProps
}) => {
  const [open, setOpen] = (0, import_react.useState)(startOpen || false);
  (0, import_react.useEffect)(() => {
    setOpen(visibility);
  }, [visibility]);
  (0, import_react.useEffect)(() => {
    if (!onOpenChange) {
      return;
    }
    onOpenChange(open);
  }, [open, onOpenChange]);
  const toggleVisibility = () => setOpen(import_helpers.toggle);
  const hide = () => setOpen(false);
  const Component = onboarding ? OnboardingTooltip : tooltipComponent;
  const extraProps = onboarding ? {
    PopperProps: {
      disablePortal: true,
      popperOptions: {
        strategy: "fixed",
        modifiers: [
          { name: "flip", enabled: false },
          { name: "preventOverflow", enabled: true, options: { boundary: window, altBoundary: false } }
        ]
      }
    }
  } : {};
  return /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(import_material2.ClickAwayListener, { onClickAway: hide, children: /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
    Component,
    {
      arrow: !onboarding,
      open,
      disableFocusListener: true,
      disableHoverListener: true,
      disableTouchListener: true,
      onOpen: () => setOpen(true),
      ...extraProps,
      ...remainingProps,
      children: /* @__PURE__ */ (0, import_jsx_runtime2.jsx)("div", { onClick: toggleVisibility, children })
    }
  ) });
};
var iconWidth = 30;
var OnboardingTooltip = (0, import_mui.withStyles)(import_material2.Tooltip, (theme) => ({
  arrow: {
    color: theme.palette.primary.main
  },
  tooltip: {
    backgroundColor: theme.palette.primary.main,
    boxShadow: theme.shadows[1],
    color: theme.palette.grey[500],
    fontSize: 14,
    maxWidth: 350,
    padding: "12px 18px",
    width: 350,
    "& a": {
      color: theme.palette.grey[500]
    },
    "&.MuiTooltip-tooltipPlacementTop": { marginLeft: iconWidth, marginBottom: 0, marginTop: `calc(${iconWidth} + ${theme.spacing(1.5)})` },
    "&.MuiTooltip-tooltipPlacementRight": { marginTop: iconWidth / 2 },
    "&.MuiTooltip-tooltipPlacementBottom": { marginLeft: iconWidth },
    "&.MuiTooltip-tooltipPlacementLeft": { marginTop: iconWidth / 2 }
  },
  popper: {
    opacity: 0.9
  }
}));
var tooltipStateStyleMap = {
  [import_constants.READ_STATES.read]: "read muted",
  default: ""
};

// src/DocsLink.tsx
var import_jsx_runtime3 = require("react/jsx-runtime");
var useStyles2 = (0, import_mui2.makeStyles)()((theme) => ({
  iconAura: {
    position: "absolute",
    top: -6,
    bottom: -4,
    left: -7,
    right: -6.5,
    border: `1px dashed ${theme.palette.text.disabled}`,
    borderRadius: "50%",
    "&.hovering": {
      borderColor: "transparent"
    }
  },
  chip: {
    borderStyle: "dashed",
    [`.${import_material3.chipClasses.deleteIcon}`]: {
      fontSize: "smaller"
    },
    "&.not-hovering": {
      borderColor: "transparent",
      color: theme.palette.text.disabled,
      [`.${import_material3.chipClasses.deleteIcon}`]: {
        color: theme.palette.text.disabled
      },
      [`.${import_material3.chipClasses.label}`]: {
        paddingLeft: 0,
        visibility: "collapse"
      }
    }
  }
}));
var DocsLink = (0, import_react2.forwardRef)(({ children, className = "", path, title = "", ...remainder }, ref) => {
  const docsVersion = (0, import_react_redux2.useSelector)(import_selectors.getDocsVersion);
  const { isHosted } = (0, import_react_redux2.useSelector)(import_selectors.getFeatures);
  const target = `https://docs.mender.io/${docsVersion}${path}`;
  const onClickHandler = () => {
    const docsParams = { headers: { "x-mender-docs": docsVersion } };
    fetch(target, isHosted ? {} : docsParams);
  };
  return (
    // eslint-disable-next-line react/jsx-no-target-blank
    /* @__PURE__ */ (0, import_jsx_runtime3.jsx)("a", { className, ...remainder, href: target, onClick: onClickHandler, ref, target: "_blank", rel: isHosted ? "noopener" : "", children: children ? children : title })
  );
});
DocsLink.displayName = "DocsLink";
var DocsLink_default = DocsLink;

// src/InfoText.tsx
var import_mui3 = require("tss-react/mui");
var import_jsx_runtime4 = require("react/jsx-runtime");
var useStyles3 = (0, import_mui3.makeStyles)()((theme) => ({
  default: { color: theme.palette.text.disabled, margin: "15px 0" }
}));
var InfoText = ({ children, className = "", variant, ...props }) => {
  const { classes } = useStyles3();
  const Component = variant === "dense" ? "span" : "p";
  return /* @__PURE__ */ (0, import_jsx_runtime4.jsx)(Component, { className: `${classes.default} ${className}`, ...props, children });
};
var InfoText_default = InfoText;

// src/Loader.tsx
var import_jsx_runtime5 = require("react/jsx-runtime");
var Loader = (props) => {
  const { fade, show, small, style, table, waiting } = props;
  const hideClass = fade ? "hidden" : "loaderContainer shrunk";
  const showClass = table ? "miniLoaderContainer" : "loaderContainer";
  return /* @__PURE__ */ (0, import_jsx_runtime5.jsx)("div", { style, className: show ? showClass : hideClass, children: /* @__PURE__ */ (0, import_jsx_runtime5.jsxs)("div", { className: `${small ? "small" : ""} ${waiting ? "waiting-loader" : ""} loader`, children: [
    /* @__PURE__ */ (0, import_jsx_runtime5.jsx)("span", { className: "dot dot_1" }),
    /* @__PURE__ */ (0, import_jsx_runtime5.jsx)("span", { className: "dot dot_2" }),
    /* @__PURE__ */ (0, import_jsx_runtime5.jsx)("span", { className: "dot dot_3" }),
    /* @__PURE__ */ (0, import_jsx_runtime5.jsx)("span", { className: "dot dot_4" })
  ] }) });
};
var Loader_default = Loader;

// src/dialogs/PhysicalDeviceOnboarding.tsx
var import_react4 = require("react");
var import_react_redux3 = require("react-redux");
var import_react_router_dom = require("react-router-dom");
var import_icons_material4 = require("@mui/icons-material");
var import_material5 = require("@mui/material");
var import_useAutocomplete = require("@mui/material/useAutocomplete");
var import_helptips = require("@northern.tech/common-ui/helptips");
var import_constants4 = require("@northern.tech/store/constants");
var import_selectors2 = require("@northern.tech/store/selectors");
var import_thunks2 = require("@northern.tech/store/thunks");
var import_helpers2 = require("@northern.tech/utils/helpers");

// src/CopyCode.tsx
var import_react3 = require("react");
var import_react_copy_to_clipboard = __toESM(require("react-copy-to-clipboard"), 1);
var import_icons_material3 = require("@mui/icons-material");
var import_material4 = require("@mui/material");
var import_mui4 = require("tss-react/mui");
var import_constants3 = require("@northern.tech/store/constants");
var import_jsx_runtime6 = require("react/jsx-runtime");
var buttonStyle = { float: "right", margin: "-20px 0 0 10px" };
var useStyles4 = (0, import_mui4.makeStyles)()((theme) => ({
  code: {
    border: "1px solid",
    borderColor: theme.palette.background.lightgrey,
    backgroundColor: theme.palette.background.lightgrey
  }
}));
var Code = ({ className = "", children, style = {} }) => {
  const { classes } = useStyles4();
  return /* @__PURE__ */ (0, import_jsx_runtime6.jsx)("div", { className: `code ${classes.code} ${className}`, style, children });
};
var CopyCode = ({ code, onCopy, withDescription }) => {
  const [copied, setCopied] = (0, import_react3.useState)(false);
  const onCopied = (_text, result) => {
    setCopied(result);
    setTimeout(() => setCopied(false), import_constants3.TIMEOUTS.fiveSeconds);
    if (onCopy) {
      onCopy();
    }
  };
  return /* @__PURE__ */ (0, import_jsx_runtime6.jsxs)(import_jsx_runtime6.Fragment, { children: [
    /* @__PURE__ */ (0, import_jsx_runtime6.jsxs)(Code, { children: [
      /* @__PURE__ */ (0, import_jsx_runtime6.jsx)(import_react_copy_to_clipboard.default, { text: code, onCopy: onCopied, children: withDescription ? /* @__PURE__ */ (0, import_jsx_runtime6.jsx)(import_material4.Button, { style: buttonStyle, startIcon: /* @__PURE__ */ (0, import_jsx_runtime6.jsx)(import_icons_material3.FileCopy, {}), children: "Copy to clipboard" }) : /* @__PURE__ */ (0, import_jsx_runtime6.jsx)(import_material4.IconButton, { style: buttonStyle, size: "large", children: /* @__PURE__ */ (0, import_jsx_runtime6.jsx)(import_icons_material3.FileCopy, {}) }) }),
      /* @__PURE__ */ (0, import_jsx_runtime6.jsx)("span", { style: { whiteSpace: "pre-wrap", wordBreak: "break-word" }, children: code })
    ] }),
    /* @__PURE__ */ (0, import_jsx_runtime6.jsx)("p", { children: copied && /* @__PURE__ */ (0, import_jsx_runtime6.jsx)("span", { className: "green fadeIn", children: "Copied to clipboard." }) })
  ] });
};
var CopyCode_default = CopyCode;

// src/dialogs/PhysicalDeviceOnboarding.tsx
var import_jsx_runtime7 = require("react/jsx-runtime");
var filter = (0, import_useAutocomplete.createFilterOptions)();
var types = [
  { title: "Raspberry Pi 3", value: "raspberrypi3" },
  { title: "Raspberry Pi 4", value: "raspberrypi4" }
];
var ConvertedImageNote = () => /* @__PURE__ */ (0, import_jsx_runtime7.jsxs)("p", { children: [
  "We prepared an image, ready for Mender, for you to start with. You can find it in the",
  " ",
  /* @__PURE__ */ (0, import_jsx_runtime7.jsx)(DocsLink_default, { path: "get-started/preparation/prepare-a-raspberry-pi-device", title: "Prepare a Raspberry Pi device" }),
  " documentation, which also contains instructions for initial device setup. Once you're done flashing you can go ahead and proceed to the next step."
] });
var IntegrationsLink = () => /* @__PURE__ */ (0, import_jsx_runtime7.jsx)(import_react_router_dom.Link, { to: "/settings/integrations", target: "_blank", children: "Integration settings" });
var ExternalProviderTip = ({ hasExternalIntegration, integrationProvider: integrationProvider2 }) => /* @__PURE__ */ (0, import_jsx_runtime7.jsx)(
  MenderTooltipClickable,
  {
    className: "clickable flexbox muted",
    placement: "bottom",
    style: { alignItems: "end", marginBottom: 3 },
    title: /* @__PURE__ */ (0, import_jsx_runtime7.jsx)("div", { style: { maxWidth: 350 }, children: hasExternalIntegration ? /* @__PURE__ */ (0, import_jsx_runtime7.jsxs)("p", { children: [
      "Devices added here will be automatically integrated with the ",
      /* @__PURE__ */ (0, import_jsx_runtime7.jsx)("i", { children: import_constants4.EXTERNAL_PROVIDER[integrationProvider2].title }),
      " you set in the",
      " ",
      /* @__PURE__ */ (0, import_jsx_runtime7.jsx)(IntegrationsLink, {}),
      "."
    ] }) : /* @__PURE__ */ (0, import_jsx_runtime7.jsxs)("p", { children: [
      "To connect your devices with ",
      /* @__PURE__ */ (0, import_jsx_runtime7.jsx)("i", { children: import_constants4.EXTERNAL_PROVIDER[integrationProvider2].title }),
      ", go to ",
      /* @__PURE__ */ (0, import_jsx_runtime7.jsx)(IntegrationsLink, {}),
      " and set up the integration."
    ] }) }),
    children: /* @__PURE__ */ (0, import_jsx_runtime7.jsx)(import_icons_material4.InfoOutlined, {})
  }
);
var DeviceTypeSelectionStep = ({
  hasConvertedImage,
  hasExternalIntegration,
  integrationProvider: integrationProvider2,
  onboardingState,
  onSelect,
  selection = "",
  version
}) => {
  const shouldShowOnboardingTip = !onboardingState.complete && onboardingState.showTips;
  const hasExternalIntegrationSupport = (0, import_helpers2.versionCompare)(version, "3.2") > -1;
  return /* @__PURE__ */ (0, import_jsx_runtime7.jsxs)(import_jsx_runtime7.Fragment, { children: [
    /* @__PURE__ */ (0, import_jsx_runtime7.jsx)("h4", { children: "Enter your device type" }),
    /* @__PURE__ */ (0, import_jsx_runtime7.jsx)("p", { children: "Setting this attribute on the device ensures that the device will only receive updates for compatible software releases." }),
    /* @__PURE__ */ (0, import_jsx_runtime7.jsxs)("div", { style: { display: "grid", gridTemplateColumns: "max-content 50px 150px", placeItems: "end center" }, children: [
      /* @__PURE__ */ (0, import_jsx_runtime7.jsx)(
        import_material5.Autocomplete,
        {
          id: "device-type-selection",
          autoSelect: true,
          autoHighlight: true,
          filterSelectedOptions: true,
          freeSolo: true,
          getOptionLabel: (option) => {
            if (typeof option === "string") {
              return option;
            }
            if (option.key === "custom" && option.value === selection) {
              return option.value;
            }
            return option.title;
          },
          handleHomeEndKeys: true,
          includeInputInList: true,
          filterOptions: (options, params) => {
            const filtered = filter(options, params);
            if (filtered.length !== 1 && params.inputValue !== "") {
              filtered.push({
                value: params.inputValue,
                key: "custom",
                title: `Use "${params.inputValue}"`
              });
            }
            return filtered;
          },
          options: types,
          onChange: onSelect,
          renderInput: (params) => /* @__PURE__ */ (0, import_jsx_runtime7.jsx)(import_material5.TextField, { ...params, label: "Device type", placeholder: "Choose a device type", InputProps: { ...params.InputProps }, style: { marginTop: 0 } }),
          style: { maxWidth: 300 },
          value: selection
        }
      ),
      hasExternalIntegrationSupport && /* @__PURE__ */ (0, import_jsx_runtime7.jsx)(ExternalProviderTip, { hasExternalIntegration, integrationProvider: integrationProvider2 }),
      shouldShowOnboardingTip ? /* @__PURE__ */ (0, import_jsx_runtime7.jsx)(import_helptips.MenderHelpTooltip, { id: import_helptips.HELPTOOLTIPS.deviceTypeTip.id, placement: "bottom" }) : /* @__PURE__ */ (0, import_jsx_runtime7.jsx)("div", {})
    ] }),
    hasConvertedImage && /* @__PURE__ */ (0, import_jsx_runtime7.jsx)(ConvertedImageNote, {})
  ] });
};
var InstallationStep = ({ advanceOnboarding: advanceOnboarding3, selection, onboardingState, ...remainingProps }) => {
  const codeToCopy = (0, import_helpers2.getDebConfigurationCode)({ ...remainingProps, deviceType: selection, isOnboarding: !onboardingState.complete });
  return /* @__PURE__ */ (0, import_jsx_runtime7.jsxs)(import_jsx_runtime7.Fragment, { children: [
    /* @__PURE__ */ (0, import_jsx_runtime7.jsx)("h4", { children: "Log into your device and install the Mender client" }),
    /* @__PURE__ */ (0, import_jsx_runtime7.jsxs)("p", { children: [
      "Copy & paste and run this command ",
      /* @__PURE__ */ (0, import_jsx_runtime7.jsx)("b", { children: "on your device" }),
      ":"
    ] }),
    /* @__PURE__ */ (0, import_jsx_runtime7.jsx)(CopyCode_default, { code: codeToCopy, onCopy: () => advanceOnboarding3(import_constants4.onboardingSteps.DASHBOARD_ONBOARDING_START), withDescription: true }),
    /* @__PURE__ */ (0, import_jsx_runtime7.jsx)("p", { children: "This downloads the Mender client on the device, sets the configuration and starts the client." }),
    /* @__PURE__ */ (0, import_jsx_runtime7.jsx)("p", { children: "Once the client has started, your device will attempt to connect to the server. It will then appear in your Pending devices tab and you can continue." })
  ] });
};
var steps = {
  1: DeviceTypeSelectionStep,
  2: InstallationStep
};
var integrationProvider = import_constants4.EXTERNAL_PROVIDER["iot-hub"].provider;
var PhysicalDeviceOnboarding = ({ progress }) => {
  const [selection, setSelection] = (0, import_react4.useState)("");
  const hasExternalIntegration = (0, import_react_redux3.useSelector)((state) => {
    const { credentials = {} } = state.organization.externalDeviceIntegrations.find((integration) => integration.provider === integrationProvider) ?? {};
    const { [import_constants4.EXTERNAL_PROVIDER["iot-hub"].credentialsAttribute]: azureConnectionString = "" } = credentials;
    return !!azureConnectionString;
  });
  const ipAddress = (0, import_react_redux3.useSelector)((state) => state.app.hostAddress);
  const isEnterprise = (0, import_react_redux3.useSelector)(import_selectors2.getIsEnterprise);
  const { isDemoMode, isHosted } = (0, import_react_redux3.useSelector)(import_selectors2.getFeatures);
  const isPreRelease = (0, import_react_redux3.useSelector)(import_selectors2.getIsPreview);
  const onboardingState = (0, import_react_redux3.useSelector)(import_selectors2.getOnboardingState);
  const { tenant_token: tenantToken } = (0, import_react_redux3.useSelector)(import_selectors2.getOrganization);
  const { Integration: version } = (0, import_react_redux3.useSelector)(import_selectors2.getFullVersionInformation);
  const { token } = (0, import_react_redux3.useSelector)(import_selectors2.getCurrentSession);
  const { hasMonitor } = (0, import_react_redux3.useSelector)(import_selectors2.getTenantCapabilities);
  const dispatch = (0, import_react_redux3.useDispatch)();
  (0, import_react4.useEffect)(() => {
    dispatch((0, import_thunks2.setOnboardingApproach)("physical"));
  }, [dispatch]);
  const onSelect = (e, deviceType, reason) => {
    if (reason === "selectOption") {
      dispatch((0, import_thunks2.setOnboardingDeviceType)(deviceType.value));
      setSelection(deviceType.value);
    } else if (reason === "clear") {
      dispatch((0, import_thunks2.setOnboardingDeviceType)(""));
      setSelection("");
    }
  };
  const hasConvertedImage = !!selection && selection.length && (selection.startsWith("raspberrypi3") || selection.startsWith("raspberrypi4"));
  const ComponentToShow = steps[progress];
  return /* @__PURE__ */ (0, import_jsx_runtime7.jsx)(
    ComponentToShow,
    {
      advanceOnboarding: (step) => dispatch((0, import_thunks2.advanceOnboarding)(step)),
      hasConvertedImage,
      hasExternalIntegration,
      hasMonitor,
      integrationProvider,
      ipAddress,
      isEnterprise,
      isHosted,
      isDemoMode,
      isPreRelease,
      onboardingState,
      onSelect,
      selection,
      tenantToken,
      token,
      version
    }
  );
};
var PhysicalDeviceOnboarding_default = PhysicalDeviceOnboarding;

// src/dialogs/VirtualDeviceOnboarding.tsx
var import_react5 = require("react");
var import_react_redux4 = require("react-redux");
var import_selectors3 = require("@northern.tech/store/selectors");
var import_thunks3 = require("@northern.tech/store/thunks");
var import_jsx_runtime8 = require("react/jsx-runtime");
var getDemoDeviceCreationCommand = (tenantToken, demoArtifactPort) => tenantToken ? `TENANT_TOKEN='${tenantToken}'
docker run -it -p ${demoArtifactPort}:${demoArtifactPort} -e SERVER_URL='https://${window.location.hostname}' \\
-e TENANT_TOKEN=$TENANT_TOKEN --pull=always mendersoftware/mender-client-qemu` : "./demo --client up";
var VirtualDeviceOnboarding = () => {
  const dispatch = (0, import_react_redux4.useDispatch)();
  const { isHosted } = (0, import_react_redux4.useSelector)(import_selectors3.getFeatures);
  const { tenant_token: tenantToken } = (0, import_react_redux4.useSelector)(import_selectors3.getOrganization);
  const demoArtifactPort = (0, import_react_redux4.useSelector)((state) => state.onboarding.demoArtifactPort);
  (0, import_react5.useEffect)(() => {
    dispatch((0, import_thunks3.setOnboardingApproach)("virtual"));
  }, [dispatch]);
  const codeToCopy = getDemoDeviceCreationCommand(tenantToken, demoArtifactPort);
  return /* @__PURE__ */ (0, import_jsx_runtime8.jsxs)("div", { children: [
    isHosted ? /* @__PURE__ */ (0, import_jsx_runtime8.jsxs)("div", { children: [
      /* @__PURE__ */ (0, import_jsx_runtime8.jsx)("b", { children: "1. Get Docker Engine" }),
      /* @__PURE__ */ (0, import_jsx_runtime8.jsx)("p", { children: "If you do not have it already, please install Docker on your local machine." }),
      /* @__PURE__ */ (0, import_jsx_runtime8.jsxs)("p", { children: [
        "For example if you are using Ubuntu follow this tutorial:",
        " ",
        /* @__PURE__ */ (0, import_jsx_runtime8.jsx)("a", { href: "https://docs.docker.com/engine/installation/linux/docker-ce/ubuntu/", target: "_blank", rel: "noopener noreferrer", children: "https://docs.docker.com/engine/installation/linux/docker-ce/ubuntu/" })
      ] })
    ] }) : /* @__PURE__ */ (0, import_jsx_runtime8.jsxs)("div", { children: [
      /* @__PURE__ */ (0, import_jsx_runtime8.jsx)("b", { children: "1. Prerequisites" }),
      /* @__PURE__ */ (0, import_jsx_runtime8.jsx)("p", { children: "As you are running Mender on-premise, for these instructions we assume that you already have Docker installed and the Mender integration environment up and running on your machine." }),
      /* @__PURE__ */ (0, import_jsx_runtime8.jsx)("p", { children: "To start a virtual device, change directory into the folder where you cloned Mender integration." })
    ] }),
    /* @__PURE__ */ (0, import_jsx_runtime8.jsx)("p", { children: /* @__PURE__ */ (0, import_jsx_runtime8.jsx)("b", { children: "2. Copy & paste and run the following command to start the virtual device:" }) }),
    /* @__PURE__ */ (0, import_jsx_runtime8.jsx)(CopyCode_default, { code: codeToCopy, withDescription: true }),
    /* @__PURE__ */ (0, import_jsx_runtime8.jsx)("p", { children: "The device should appear in the Pending devices view in a couple of minutes." }),
    /* @__PURE__ */ (0, import_jsx_runtime8.jsxs)("p", { children: [
      "Visit ",
      /* @__PURE__ */ (0, import_jsx_runtime8.jsx)(DocsLink_default, { path: "get-started/preparation/prepare-a-virtual-device", title: "our documentation" }),
      " for more information on managing the virtual device."
    ] })
  ] });
};
var VirtualDeviceOnboarding_default = VirtualDeviceOnboarding;

// src/dialogs/DeviceConnectionDialog.tsx
var import_jsx_runtime9 = require("react/jsx-runtime");
var useStyles5 = (0, import_mui5.makeStyles)()((theme) => ({
  rpiQuickstart: {
    backgroundColor: theme.palette.background.lightgrey
  },
  virtualLogo: { height: 40, marginLeft: theme.spacing(2) }
}));
var docsLinks = [
  { key: "debian", target: "operating-system-updates-debian-family", title: "Debian family" },
  { key: "yocto", target: "operating-system-updates-yocto-project", title: "Yocto OSes" }
];
var MenderHubReference = () => /* @__PURE__ */ (0, import_jsx_runtime9.jsxs)("p", { className: "padding-bottom-none", children: [
  "Or visit ",
  /* @__PURE__ */ (0, import_jsx_runtime9.jsx)("a", { href: "https://hub.mender.io/c/board-integrations", target: "_blank", rel: "noopener", children: "Mender Hub" }),
  " ",
  "and search integrations for your device and OS."
] });
var OnPremDeviceConnectionExplainer = ({ isEnterprise }) => /* @__PURE__ */ (0, import_jsx_runtime9.jsxs)(import_jsx_runtime9.Fragment, { children: [
  /* @__PURE__ */ (0, import_jsx_runtime9.jsxs)("p", { children: [
    "You can connect almost any device and Linux OS with Mender, but to make things simple during evaluation we recommend you to get started with a Debian based setup. This also works with a Raspberry Pi as a test device.",
    /* @__PURE__ */ (0, import_jsx_runtime9.jsx)("br", {}),
    "Follow the ",
    /* @__PURE__ */ (0, import_jsx_runtime9.jsx)(DocsLink_default, { path: "client-installation/install-with-debian-package", title: "installation instructions" }),
    " for Debian packages and select the",
    " ",
    isEnterprise ? "Enterprise" : "Demo",
    " server tab to configure the client."
  ] }),
  /* @__PURE__ */ (0, import_jsx_runtime9.jsx)("div", { children: "For operating system updates, see the documentation to integrate the following with Mender:" }),
  /* @__PURE__ */ (0, import_jsx_runtime9.jsx)("ul", { children: docsLinks.map((item) => /* @__PURE__ */ (0, import_jsx_runtime9.jsx)("li", { children: /* @__PURE__ */ (0, import_jsx_runtime9.jsx)(DocsLink_default, { path: item.target, title: item.title }) }, item.key)) }),
  /* @__PURE__ */ (0, import_jsx_runtime9.jsx)(MenderHubReference, {})
] });
var DeviceConnectionExplainer = ({ hasMonitor, setOnDevice, setVirtualDevice }) => {
  const { classes } = useStyles5();
  return /* @__PURE__ */ (0, import_jsx_runtime9.jsxs)(import_jsx_runtime9.Fragment, { children: [
    /* @__PURE__ */ (0, import_jsx_runtime9.jsx)("p", { children: "You can connect almost any device and Linux OS with Mender, but to make things simple during evaluation we recommend you use a Raspberry Pi as a test device." }),
    /* @__PURE__ */ (0, import_jsx_runtime9.jsxs)("div", { className: `padding-small padding-top-none rpi-quickstart ${classes.rpiQuickstart}`, children: [
      /* @__PURE__ */ (0, import_jsx_runtime9.jsx)("h3", { children: "Raspberry Pi quick start" }),
      /* @__PURE__ */ (0, import_jsx_runtime9.jsx)("p", { children: "We'll walk you through the steps to connect a Raspberry Pi and deploy your first update with Mender." }),
      /* @__PURE__ */ (0, import_jsx_runtime9.jsxs)("div", { className: "flexbox column centered", children: [
        /* @__PURE__ */ (0, import_jsx_runtime9.jsx)("div", { className: "flexbox centered os-list", children: [raspberrypi_default, raspberrypi4_default].map((tile, index) => /* @__PURE__ */ (0, import_jsx_runtime9.jsx)("img", { src: tile }, `tile-${index}`)) }),
        /* @__PURE__ */ (0, import_jsx_runtime9.jsx)(import_material6.Button, { variant: "contained", color: "secondary", onClick: () => setOnDevice(true), children: "Get Started" })
      ] })
    ] }),
    /* @__PURE__ */ (0, import_jsx_runtime9.jsxs)("div", { className: "two-columns margin-top", children: [
      /* @__PURE__ */ (0, import_jsx_runtime9.jsxs)("div", { className: "padding-small padding-top-none", children: [
        /* @__PURE__ */ (0, import_jsx_runtime9.jsxs)("div", { className: "flexbox center-aligned", children: [
          /* @__PURE__ */ (0, import_jsx_runtime9.jsx)("h3", { children: "Use a virtual device" }),
          /* @__PURE__ */ (0, import_jsx_runtime9.jsx)("img", { src: docker_default, className: classes.virtualLogo })
        ] }),
        /* @__PURE__ */ (0, import_jsx_runtime9.jsx)("p", { className: "margin-top-none", children: "Don't have a Raspberry Pi?" }),
        /* @__PURE__ */ (0, import_jsx_runtime9.jsx)("p", { children: "You can use our Docker-run virtual device to go through the same tutorial." }),
        hasMonitor && /* @__PURE__ */ (0, import_jsx_runtime9.jsx)(InfoText_default, { className: "slightly-smaller", children: "If you want to evaluate our commercial components such as mender-monitor, please use a physical device instead as the virtual client does not support these components at this time." }),
        /* @__PURE__ */ (0, import_jsx_runtime9.jsx)("a", { onClick: () => setVirtualDevice(true), children: "Try a virtual device" })
      ] }),
      /* @__PURE__ */ (0, import_jsx_runtime9.jsxs)("div", { className: "padding-small padding-top-none", children: [
        /* @__PURE__ */ (0, import_jsx_runtime9.jsx)("h3", { children: "Other devices" }),
        /* @__PURE__ */ (0, import_jsx_runtime9.jsx)("div", { children: "See the documentation to integrate the following with Mender:" }),
        /* @__PURE__ */ (0, import_jsx_runtime9.jsx)("ul", { children: docsLinks.map((item) => /* @__PURE__ */ (0, import_jsx_runtime9.jsx)("li", { children: /* @__PURE__ */ (0, import_jsx_runtime9.jsx)(DocsLink_default, { path: item.target, title: item.title }) }, item.key)) }),
        /* @__PURE__ */ (0, import_jsx_runtime9.jsx)(MenderHubReference, {})
      ] })
    ] }),
    /* @__PURE__ */ (0, import_jsx_runtime9.jsx)(import_helptips2.MenderHelpTooltip, { id: import_helptips2.HELPTOOLTIPS.deviceSupportTip.id, style: { position: "absolute", bottom: "2.5%", left: "88%" } })
  ] });
};
var DeviceConnectionDialog = ({ onCancel }) => {
  const [onDevice, setOnDevice] = (0, import_react6.useState)(false);
  const [progress, setProgress] = (0, import_react6.useState)(1);
  const [virtualDevice, setVirtualDevice] = (0, import_react6.useState)(false);
  const { pending: pendingCount } = (0, import_react_redux5.useSelector)(import_selectors4.getDeviceCountsByStatus);
  const [pendingDevicesCount] = (0, import_react6.useState)(pendingCount);
  const [hasMoreDevices, setHasMoreDevices] = (0, import_react6.useState)(false);
  const { isEnterprise, hasMonitor } = (0, import_react_redux5.useSelector)(import_selectors4.getTenantCapabilities);
  const { isHosted } = (0, import_react_redux5.useSelector)(import_selectors4.getFeatures);
  const { complete: onboardingComplete, deviceType: onboardingDeviceType } = (0, import_react_redux5.useSelector)(import_selectors4.getOnboardingState);
  const dispatch = (0, import_react_redux5.useDispatch)();
  const navigate = (0, import_react_router_dom2.useNavigate)();
  (0, import_react6.useEffect)(() => {
    setHasMoreDevices(pendingCount > pendingDevicesCount);
  }, [pendingDevicesCount, pendingCount]);
  (0, import_react6.useEffect)(() => {
    if ((virtualDevice || progress >= 2) && hasMoreDevices && !window.location.hash.includes("pending")) {
      dispatch((0, import_thunks4.advanceOnboarding)(import_constants5.onboardingSteps.DASHBOARD_ONBOARDING_START));
      dispatch((0, import_thunks4.setDeviceListState)({ state: import_constants5.DEVICE_STATES.pending }));
      navigate("/devices/pending");
    }
    if (virtualDevice || progress >= 2) {
      dispatch((0, import_thunks4.saveUserSettings)({ onboarding: { deviceConnection: (/* @__PURE__ */ new Date()).toISOString() } }));
    }
  }, [dispatch, hasMoreDevices, navigate, progress, virtualDevice]);
  const onBackClick = () => {
    let updatedProgress = progress - 1;
    if (!updatedProgress) {
      updatedProgress = 1;
      setOnDevice(false);
      setVirtualDevice(false);
    }
    setProgress(updatedProgress);
  };
  const onAdvance = () => {
    dispatch((0, import_thunks4.advanceOnboarding)(import_constants5.onboardingSteps.DASHBOARD_ONBOARDING_START));
    setProgress(progress + 1);
  };
  let content = /* @__PURE__ */ (0, import_jsx_runtime9.jsx)(DeviceConnectionExplainer, { hasMonitor, setOnDevice, setVirtualDevice });
  if (onDevice) {
    content = /* @__PURE__ */ (0, import_jsx_runtime9.jsx)(PhysicalDeviceOnboarding_default, { progress });
  } else if (virtualDevice) {
    content = /* @__PURE__ */ (0, import_jsx_runtime9.jsx)(VirtualDeviceOnboarding_default, {});
  } else if (!isHosted) {
    content = /* @__PURE__ */ (0, import_jsx_runtime9.jsx)(OnPremDeviceConnectionExplainer, { isEnterprise });
  }
  if (hasMoreDevices && !onboardingComplete) {
    setTimeout(onCancel, import_constants5.TIMEOUTS.twoSeconds);
  }
  return /* @__PURE__ */ (0, import_jsx_runtime9.jsxs)(import_material6.Dialog, { open: true, maxWidth: "sm", children: [
    /* @__PURE__ */ (0, import_jsx_runtime9.jsx)(import_material6.DialogTitle, { children: "Connecting a device" }),
    /* @__PURE__ */ (0, import_jsx_runtime9.jsx)(import_material6.DialogContent, { className: "onboard-dialog padding-bottom-none margin-left margin-right", children: content }),
    /* @__PURE__ */ (0, import_jsx_runtime9.jsxs)(import_material6.DialogActions, { children: [
      /* @__PURE__ */ (0, import_jsx_runtime9.jsx)(import_material6.Button, { onClick: onCancel, children: "Cancel" }),
      /* @__PURE__ */ (0, import_jsx_runtime9.jsx)("div", { style: { flexGrow: 1 } }),
      (onDevice || virtualDevice) && /* @__PURE__ */ (0, import_jsx_runtime9.jsxs)("div", { children: [
        /* @__PURE__ */ (0, import_jsx_runtime9.jsx)(import_material6.Button, { onClick: onBackClick, children: "Back" }),
        progress < 2 && (!virtualDevice || progress < 1) ? /* @__PURE__ */ (0, import_jsx_runtime9.jsx)(import_material6.Button, { variant: "contained", disabled: !(virtualDevice || onDevice && onboardingDeviceType), onClick: onAdvance, children: "Next" }) : /* @__PURE__ */ (0, import_jsx_runtime9.jsx)(
          import_material6.Button,
          {
            variant: "contained",
            disabled: !onboardingComplete,
            onClick: onCancel,
            endIcon: !onboardingComplete && /* @__PURE__ */ (0, import_jsx_runtime9.jsx)(Loader_default, { show: true, small: true, table: true, style: { top: -24 } }),
            children: onboardingComplete ? "Close" : "Waiting for device"
          }
        )
      ] })
    ] })
  ] });
};

// src/dialogs/Feedback.tsx
var import_react7 = require("react");
var import_react_redux6 = require("react-redux");
var import_icons_material5 = require("@mui/icons-material");
var import_material7 = require("@mui/material");
var import_mui6 = require("tss-react/mui");
var import_actions2 = __toESM(require("@northern.tech/store/actions"), 1);
var import_constants6 = require("@northern.tech/store/constants");
var import_thunks5 = require("@northern.tech/store/thunks");
var import_utils = require("@northern.tech/store/utils");
var import_jsx_runtime10 = require("react/jsx-runtime");
var { setShowFeedbackDialog } = import_actions2.default;
var useStyles6 = (0, import_mui6.makeStyles)()((theme) => ({
  root: {
    pointerEvents: "none",
    [`.${import_material7.dialogClasses.paper}`]: { width: 350, bottom: 0, right: 0, position: "absolute" },
    [`.${import_material7.dialogTitleClasses.root}`]: {
      alignSelf: "flex-end",
      padding: 0,
      [`.${import_material7.iconButtonClasses.root}`]: { marginBottom: theme.spacing(-1) }
    },
    ".title": {
      color: (0, import_utils.isDarkMode)(theme.palette.mode) ? (0, import_material7.lighten)(theme.palette.primary.main, 0.85) : "inherit"
    }
  },
  columns: { gap: theme.spacing(2) },
  rating: {
    [`.${import_material7.iconButtonClasses.root}`]: {
      borderRadius: theme.shape.borderRadius,
      height: theme.spacing(6),
      width: theme.spacing(6),
      backgroundColor: (0, import_utils.isDarkMode)(theme.palette.mode) ? (0, import_material7.darken)(theme.palette.primary.main, 0.45) : (0, import_material7.lighten)(theme.palette.primary.main, 0.85),
      color: theme.palette.primary.main,
      "&:hover": {
        backgroundColor: theme.palette.primary.main,
        color: (0, import_material7.lighten)(theme.palette.primary.main, 0.85)
      }
    }
  },
  text: { [`.${import_material7.textFieldClasses.root}`]: { marginTop: 0 }, ".submitButton": { alignSelf: "start" } }
}));
var satisfactionLevels = [
  { Icon: import_icons_material5.SentimentVeryDissatisfiedOutlined, title: "Very Dissatisfied" },
  { Icon: import_icons_material5.SentimentVeryDissatisfied, title: "Dissatisfied" },
  { Icon: import_icons_material5.SentimentNeutral, title: "Neutral" },
  { Icon: import_icons_material5.SentimentSatisfiedAlt, title: "Satisfied" },
  { Icon: import_icons_material5.SentimentVerySatisfiedOutlined, title: "Very Satisfied" }
];
var explanations = ["Very unsatisfied", "Very satisfied"];
var SatisfactionGauge = ({ classes, setSatisfaction }) => /* @__PURE__ */ (0, import_jsx_runtime10.jsxs)("div", { className: `flexbox column ${classes.columns}`, children: [
  /* @__PURE__ */ (0, import_jsx_runtime10.jsx)("div", { className: "title", children: "How satisfied are you with Mender?" }),
  /* @__PURE__ */ (0, import_jsx_runtime10.jsx)("div", { className: `flexbox space-between ${classes.rating}`, children: satisfactionLevels.map(({ Icon, title }, index) => /* @__PURE__ */ (0, import_jsx_runtime10.jsx)(import_material7.IconButton, { onClick: () => setSatisfaction(index), title, children: /* @__PURE__ */ (0, import_jsx_runtime10.jsx)(Icon, { fontSize: "large" }) }, `satisfaction-${index}`)) }),
  /* @__PURE__ */ (0, import_jsx_runtime10.jsx)("div", { className: "flexbox space-between muted", children: explanations.map((explanation, index) => /* @__PURE__ */ (0, import_jsx_runtime10.jsx)("div", { className: "slightly-smaller", children: explanation }, `explanation-${index}`)) })
] });
var TextEntry = ({ classes, feedback, onChangeFeedback, onSubmit }) => /* @__PURE__ */ (0, import_jsx_runtime10.jsxs)("div", { className: `flexbox column ${classes.columns} ${classes.text}`, children: [
  /* @__PURE__ */ (0, import_jsx_runtime10.jsx)("div", { className: "title", children: "What do you think is the most important thing to improve in Mender? (optional)" }),
  /* @__PURE__ */ (0, import_jsx_runtime10.jsx)(
    import_material7.TextField,
    {
      placeholder: "Your feedback",
      multiline: true,
      minRows: 4,
      onChange: ({ target: { value } }) => onChangeFeedback(value),
      value: feedback,
      variant: "outlined"
    }
  ),
  /* @__PURE__ */ (0, import_jsx_runtime10.jsx)(import_material7.Button, { className: "submitButton", variant: "contained", onClick: onSubmit, children: "Submit Feedback" })
] });
var AppreciationNote = () => /* @__PURE__ */ (0, import_jsx_runtime10.jsx)("p", { className: "margin-top-none align-center title", children: "Thank you for taking the time to share your thoughts!" });
var progressionLevels = [SatisfactionGauge, TextEntry, AppreciationNote];
var FeedbackDialog = () => {
  const [progress, setProgress] = (0, import_react7.useState)(0);
  const [satisfaction, setSatisfaction] = (0, import_react7.useState)(-1);
  const [feedback, setFeedback] = (0, import_react7.useState)("");
  const dispatch = (0, import_react_redux6.useDispatch)();
  const isInitialized = (0, import_react7.useRef)(false);
  const { classes } = useStyles6();
  (0, import_react7.useEffect)(() => {
    if (!isInitialized.current) {
      return;
    }
    setProgress((current) => current + 1);
  }, [satisfaction]);
  (0, import_react7.useEffect)(() => {
    setTimeout(() => isInitialized.current = true, import_constants6.TIMEOUTS.oneSecond);
  }, []);
  const onCloseClick = () => dispatch(setShowFeedbackDialog(false));
  const onSubmit = () => {
    setProgress(progress + 1);
    dispatch((0, import_thunks5.submitFeedback)({ satisfaction: satisfactionLevels[satisfaction].title, feedback }));
  };
  const Component = progressionLevels[progress];
  return /* @__PURE__ */ (0, import_jsx_runtime10.jsxs)(import_material7.Dialog, { className: classes.root, open: true, hideBackdrop: true, disableEnforceFocus: true, PaperProps: { style: { pointerEvents: "auto" } }, children: [
    /* @__PURE__ */ (0, import_jsx_runtime10.jsx)(import_material7.DialogTitle, { children: /* @__PURE__ */ (0, import_jsx_runtime10.jsx)(import_material7.IconButton, { onClick: onCloseClick, "aria-label": "close", size: "small", children: /* @__PURE__ */ (0, import_jsx_runtime10.jsx)(import_icons_material5.Close, {}) }) }),
    /* @__PURE__ */ (0, import_jsx_runtime10.jsx)(import_material7.DialogContent, { children: /* @__PURE__ */ (0, import_jsx_runtime10.jsx)(Component, { classes, feedback, setSatisfaction, onChangeFeedback: setFeedback, onSubmit }) })
  ] });
};

// src/dialogs/Log.tsx
var import_react8 = require("react");
var import_react_copy_to_clipboard2 = __toESM(require("react-copy-to-clipboard"), 1);
var import_material8 = require("@mui/material");
var import_helpers3 = require("@northern.tech/utils/helpers");
var import_jsx_runtime11 = require("react/jsx-runtime");
var wrapperStyle = { marginRight: 10, display: "inline-block" };
var dialogTypes = {
  "deviceLog": {
    title: "Deployment log for device",
    filename: ({ device, releaseName, date }) => `deployment-log-${device}-${releaseName}-${date}.log`
  },
  "configUpdateLog": {
    title: "Config update log for device",
    filename: () => "configuration-update.log"
  }
};
var LogDialog = ({ context = {}, logData = "", onClose, type = "deviceLog" }) => {
  const [copied, setCopied] = (0, import_react8.useState)(false);
  const exportLog = () => (0, import_helpers3.createFileDownload)(logData, dialogTypes[type].filename(context), "");
  return /* @__PURE__ */ (0, import_jsx_runtime11.jsxs)(import_material8.Dialog, { open: true, maxWidth: "lg", children: [
    /* @__PURE__ */ (0, import_jsx_runtime11.jsx)(import_material8.DialogTitle, { children: dialogTypes[type].title }),
    /* @__PURE__ */ (0, import_jsx_runtime11.jsxs)(import_material8.DialogContent, { children: [
      /* @__PURE__ */ (0, import_jsx_runtime11.jsx)(Code, { className: "log", children: logData }),
      /* @__PURE__ */ (0, import_jsx_runtime11.jsx)("p", { style: { marginLeft: 24 }, children: copied && /* @__PURE__ */ (0, import_jsx_runtime11.jsx)("span", { className: "green fadeIn", children: "Copied to clipboard." }) })
    ] }),
    /* @__PURE__ */ (0, import_jsx_runtime11.jsxs)(import_material8.DialogActions, { children: [
      /* @__PURE__ */ (0, import_jsx_runtime11.jsx)("div", { style: wrapperStyle, children: /* @__PURE__ */ (0, import_jsx_runtime11.jsx)(import_material8.Button, { onClick: onClose, children: "Cancel" }) }),
      /* @__PURE__ */ (0, import_jsx_runtime11.jsx)(import_react_copy_to_clipboard2.default, { style: wrapperStyle, text: logData, onCopy: () => setCopied(true), children: /* @__PURE__ */ (0, import_jsx_runtime11.jsx)(import_material8.Button, { children: "Copy to clipboard" }) }),
      /* @__PURE__ */ (0, import_jsx_runtime11.jsx)(import_material8.Button, { variant: "contained", color: "primary", onClick: exportLog, children: "Export log" })
    ] })
  ] });
};

// src/dialogs/StartupNotification.tsx
var import_react9 = require("react");
var import_react_redux7 = require("react-redux");
var import_material9 = require("@mui/material");
var import_actions3 = __toESM(require("@northern.tech/store/actions"), 1);
var import_constants7 = require("@northern.tech/store/constants");
var import_selectors5 = require("@northern.tech/store/selectors");
var import_thunks6 = require("@northern.tech/store/thunks");
var import_debouncehook3 = require("@northern.tech/utils/debouncehook");

// ../../assets/img/headerlogo.png
var headerlogo_default = "../headerlogo-QQW3XP5Y.png";

// ../../assets/img/whiteheaderlogo.png
var whiteheaderlogo_default = "../whiteheaderlogo-76DNCTF3.png";

// src/dialogs/StartupNotification.tsx
var import_jsx_runtime12 = require("react/jsx-runtime");
var { setShowStartupNotification } = import_actions3.default;
var OfflineThresholdContent = () => /* @__PURE__ */ (0, import_jsx_runtime12.jsxs)(import_jsx_runtime12.Fragment, { children: [
  "In our continuous efforts to enhance performance and to ensure the stability of our service, we have made adjustments to how granular device connectivity can be checked.",
  /* @__PURE__ */ (0, import_jsx_runtime12.jsx)("h4", { children: "What's changing:" }),
  /* @__PURE__ */ (0, import_jsx_runtime12.jsx)("ul", { children: /* @__PURE__ */ (0, import_jsx_runtime12.jsxs)("li", { children: [
    /* @__PURE__ */ (0, import_jsx_runtime12.jsx)("i", { children: "Offline threshold" }),
    " setting: if a device no longer connects with the server, it may take up to 1 day until it is shown as an offline device in the UI."
  ] }) }),
  "More granular connectivity information will still be reflected in the device details.",
  /* @__PURE__ */ (0, import_jsx_runtime12.jsx)("h4", { children: "Why are we changing this:" }),
  /* @__PURE__ */ (0, import_jsx_runtime12.jsxs)("ul", { children: [
    /* @__PURE__ */ (0, import_jsx_runtime12.jsx)("li", { children: "Performance Improvements: Less frequent updates allow us to better optimize the platform and improve overall performance." }),
    /* @__PURE__ */ (0, import_jsx_runtime12.jsx)("li", { children: "Stability: This change helps ensure that our backend will remain stable while serving an ever growing number of devices and potential disruptions are minimized." })
  ] }),
  "We appreciate your understanding and cooperation as we implement these improvements. Our commitment to providing you with a reliable and high-performing platform remains our top priority.",
  /* @__PURE__ */ (0, import_jsx_runtime12.jsx)(import_material9.Divider, { className: "margin-top-small margin-bottom-small" }),
  "If you have any questions or concerns regarding this change, please do not hesitate to",
  " ",
  /* @__PURE__ */ (0, import_jsx_runtime12.jsx)("a", { href: "mailto:support@mender.io", target: "_blank", rel: "noopener noreferrer", children: "contact our team" }),
  "."
] });
var notifications = {
  offlineThreshold: {
    Content: OfflineThresholdContent,
    action: ({ dispatch }) => dispatch((0, import_thunks6.saveGlobalSettings)({ offlineThreshold: { interval: 1, intervalUnit: import_constants7.DEVICE_ONLINE_CUTOFF.intervalName } }))
  }
};
var StartupNotificationDialog = () => {
  const [isAllowedToClose] = (0, import_react9.useState)(false);
  const dispatch = (0, import_react_redux7.useDispatch)();
  const isDarkMode2 = (0, import_react_redux7.useSelector)(import_selectors5.getIsDarkMode);
  const { action, Content } = notifications.offlineThreshold;
  const debouncedCloseGuard = (0, import_debouncehook3.useDebounce)(isAllowedToClose, import_constants7.TIMEOUTS.fiveSeconds);
  const onClose = () => {
    action({ dispatch });
    dispatch(setShowStartupNotification(false));
  };
  const headerLogo = isDarkMode2 ? whiteheaderlogo_default : headerlogo_default;
  return /* @__PURE__ */ (0, import_jsx_runtime12.jsxs)(import_material9.Dialog, { open: true, PaperProps: { className: "padding-small", sx: { maxWidth: 720 } }, children: [
    /* @__PURE__ */ (0, import_jsx_runtime12.jsxs)(import_material9.DialogTitle, { className: "flexbox center-aligned", children: [
      /* @__PURE__ */ (0, import_jsx_runtime12.jsx)("img", { src: headerLogo, style: { maxHeight: 75 } }),
      /* @__PURE__ */ (0, import_jsx_runtime12.jsx)("div", { className: "margin-left-small", children: "Welcome back!" })
    ] }),
    /* @__PURE__ */ (0, import_jsx_runtime12.jsx)(import_material9.DialogContent, { className: "margin-left-small margin-right-small", children: /* @__PURE__ */ (0, import_jsx_runtime12.jsx)(Content, {}) }),
    /* @__PURE__ */ (0, import_jsx_runtime12.jsx)(import_material9.DialogActions, { children: /* @__PURE__ */ (0, import_jsx_runtime12.jsx)(import_material9.Button, { variant: "contained", disabled: debouncedCloseGuard, onClick: onClose, children: "Close" }) })
  ] });
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  ConfirmDismissHelptips,
  ConvertedImageNote,
  DeviceConnectionDialog,
  DeviceTypeSelectionStep,
  ExternalProviderTip,
  FeedbackDialog,
  InstallationStep,
  LogDialog,
  PhysicalDeviceOnboarding,
  StartupNotificationDialog,
  VirtualDeviceOnboarding,
  getDemoDeviceCreationCommand
});
//# sourceMappingURL=index.cjs.map